<script setup lang="ts">
import { Map, LngLat, LngLatBounds } from 'maplibre-gl'
import 'maplibre-gl/dist/maplibre-gl.css'
import { onMounted, ref, useTemplateRef, type Ref } from 'vue'
let map: Map | undefined
const lngLatBounds: Ref<LngLatBounds | undefined> = ref()
const lastClikedLocation: Ref<LngLat | undefined> = ref()
const mapRef = useTemplateRef('mapRef')
const codeRef = useTemplateRef('preRef')
const description = ref('')
const name = ref('')
const time = ref('dd/mm/yyyy')

onMounted(() => {
  const tileServerUrl = import.meta.env.VITE_TILESERVER_URL
  map = new Map({
    container: 'map',
    style: `${tileServerUrl}/styles/basic/style.json`,
    center: [0, 0],
    zoom: 1,
  })
  map.on('moveend', () => (lngLatBounds.value = map!.getBounds()))
  map.on('click', (e) => (lastClikedLocation.value = e.lngLat))
})

const copyPre = () => {
  navigator.clipboard.writeText(codeRef.value!.innerText).then(() => console.log('copied'))
}
</script>

<template>
  <main>
    <div id="map" ref="mapRef"></div>

    <input type="text" v-model="name" />
    <input type="text" v-model="time" />
    <textarea name="description" id="description" v-model="description"></textarea>
    <pre ref="preRef">
    {
      name :{{ JSON.stringify(name) }},
      description: {{ JSON.stringify(description) }},
      time: new Date('{{ time.substring(6) }}-{{ time.substring(3, 5) }}-{{
        time.substring(0, 2)
      }}'),
      location: {
        latitude:{{ lastClikedLocation?.lat }},
        longitude :{{ lastClikedLocation?.lng }}
      },
      sceneBounds: new LngLatBounds(
        new LngLat({{ lngLatBounds?._sw.lng }}, {{ lngLatBounds?._sw.lat }}),
        new LngLat({{ lngLatBounds?._ne.lng }}, {{ lngLatBounds?._ne.lat }})
      ),
      imageUrl: undefined,
    },
    </pre>
    <button @click="copyPre">Copy</button>
  </main>
</template>

<style scoped>
#map {
  width: 70vh;
  height: 70vh;
  display: inline-block;
}
* {
  margin: 5px;
}
p {
  min-height: 200px;
}
</style>
